JsonCpp project page | Classes | Namespace | JsonCpp home page

Public Member Functions | List of all members
Json::StyledStreamWriter Class Reference

Writes a Value in JSON format in a human friendly way, to a stream rather than to a string. More...

`#include <json/writer.h>`

Collaboration diagram for Json::StyledStreamWriter:

## Public Member Functions
| StyledStreamWriter (String indentation="\t")
| ~StyledStreamWriter ()=default
void | write (OStream &out, const Value &root)
| Serialize a Value in JSON format.

## Detailed Description

Writes a Value in JSON format in a human friendly way, to a stream rather than to a string.

The rules for line break and indent are as follow:

- Object value:
  - if empty then print {} without indent and line break
  - if not empty the print '{', line break & indent, print one value per line and then unindent and line break and print '}'.
- Array value:
  - if empty then print [] without indent and line break
  - if the array contains no object value, empty array or some other value types, and all the values fit on one lines, then print the array on a single line.
  - otherwise, it the values do not fit on one line, or the array contains object or non empty array, then print one value per line.

If the Value have comments then they are outputted according to their CommentPlacement.

See also
  Reader, Value, Value::setComment()

Deprecated
  Use StreamWriterBuilder.

Definition at line 298 of file writer.h.

## Constructor & Destructor Documentation

## ◆ StyledStreamWriter()

Json::StyledStreamWriter::StyledStreamWriter | ( | String | indentation = "\t" | ) |

Parameters

  indentation | Each level will be indented by this amount extra.

Definition at line 654 of file json_writer.cpp.

## ◆ ~StyledStreamWriter()

Json::StyledStreamWriter::~StyledStreamWriter | ( |  | ) |
| default

## Member Function Documentation

## ◆ write()

void Json::StyledStreamWriter::write | ( | OStream & | out,
|  | const Value & | root )

Serialize a Value in JSON format.

Parameters

  out | Stream to write to. (Can be ostringstream, e.g.)
  root | Value to serialize.

Note
  There is no point in deriving from Writer, since write() should not return a value.

Definition at line 658 of file json_writer.cpp.

The documentation for this class was generated from the following files:

- include/json/writer.h
- src/lib_json/json_writer.cpp